﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_clone_with_serialization
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Person person1, person2, person3;
        private void Form1_Load(object sender, EventArgs e)
        {
            // Make a Person.
            person1 = new Person()
            {
                FirstName = "Ann",
                LastName = "Archer",
                Address = new StreetAddress() { Street = "101 Ash Ave", City = "Ann Arbor", State = "MI", Zip = "12345" },
                Email = "Ann@anywhere.com",
                Phone = "703-287-3798"
            };

            // Make shallow and deep clones.
            person2 = person1.Clone(Person.CloneType.Shallow);
            person3 = person1.DeepClone();

            // Display the objects.
            propPerson.SelectedObject = person1;
            propShallowClone.SelectedObject = person2;
            propDeepClone.SelectedObject = person3;

            propPerson.ExpandAllGridItems();
            propShallowClone.ExpandAllGridItems();
            propDeepClone.ExpandAllGridItems();
        }

        // A property value changed. Refresh all of the PropertyGrids.
        private void propGrid_PropertyValueChanged(object s, PropertyValueChangedEventArgs e)
        {
            propPerson.Refresh();
            propShallowClone.Refresh();
            propDeepClone.Refresh();
        }
    }
}
